/*
 Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
 Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
 Copyright (c) 1996-1998 The Open Group
 Copyright (c) 1994-1997 Sun Microsystems Inc.
 
 All rights reserved.
 This technology is a result of the Advanced Software  Enrichment 
 Project of Information-technology Promotion Agency, Japan (IPA).
 
 Permissions  to  use,  copy, modify and distribute this software
 are governed by the terms and conditions set forth in  the  file 
 COPYRIGHT, located in the top directory of this software.

 ************************************************************************

$Source: /togdev/cvsroot/adl2/src/examples/c/bank_example/bankAccount.c,v $
$Revision: 1.2 $
$Date: 1998/02/27 15:22:48 $
 PRODUCT:	Assertion Definition Language Translation System
                (ADLTS) Version 2.0
 COMPONENT:	bank example (C)
 NAME:	bankAccount.cc
 	
 HISTORY:
 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
 		
 ************************************************************************/
#include "bankAccount.h"


bankAccount *
createBankAccount(long acct, long bal)
{

  bankAccount *ret;

  if (bal < 0) {
    bankError = negativeAmountExc;
    return NULL;
  }
  ret = (bankAccount *) malloc (sizeof(bankAccount));
  if (!ret) {
    return NULL;
  }
  ret->acct_number = acct;
  ret->balance     = bal;

  return (ret);

}

long
deposit(bankAccount *ba, long amt)
{

  if (ba == NULL) {
    bankError = invalidAccountExc;
    return -1;
  }

  if (amt < 0) {
    bankError = negativeAmountExc;
    return -1;
  }

  ba->balance += amt;
  return ba->balance;
}

long
withdraw(bankAccount *ba,long amt)
{
  if (ba == NULL) {
    bankError = invalidAccountExc;
    return -1;
  }

  if (amt < 0) {
    bankError = negativeAmountExc;
    return -1;
  }
  if (ba->balance - amt < 0) {
    bankError = insufficientFundsExc;
    return -1;
  }
  ba->balance -= amt;
  return ba->balance;
}
