/*
 Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
 Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
 Copyright (c) 1996-1998 The Open Group
 Copyright (c) 1994-1997 Sun Microsystems Inc.
 
 All rights reserved.
 This technology is a result of the Advanced Software  Enrichment 
 Project of Information-technology Promotion Agency, Japan (IPA).
 
 Permissions  to  use,  copy, modify and distribute this software
 are governed by the terms and conditions set forth in  the  file 
 COPYRIGHT, located in the top directory of this software.
 */
/************************************************************************

$Source: /togdev/cvsroot/adl2/src/examples/c/simple_bank/bank.c,v $
$Revision: 1.2 $
$Date: 1998/05/11 14:42:44 $
PRODUCT:	Assertion Definition Language Translator (ADLT)
COMPONENT:	ADL 1 bank example rewritten for ADL version 2
NAME:		bank.c

HISTORY:
	Matt Evans, Sun Microsystems Inc. - Nov 3, 1996: Created
************************************************************************/

/*
 * bank.c
 *
 * C-language implementation of the bank module
 */


#include "bank.h"

int bank_errno;

int bal[MAX_ACCOUNT_NUM + 1];


int deposit(int account_number, int amount)
{
  bank_errno = 0;

  if (account_number < 1 || account_number > MAX_ACCOUNT_NUM) {
    bank_errno = INVALID_ACCOUNT;
    return -1;
  }
  if (amount < 0) {
      bank_errno = NEGATIVE_AMOUNT;
      return -1;
  }

  bal[account_number] += amount;
  return(bal[account_number]);
}

int withdraw(int account_number, int amount)
{

    bank_errno = 0;

    if (account_number < 1 || account_number > MAX_ACCOUNT_NUM) {
      bank_errno = INVALID_ACCOUNT;
      return (-1);
    }
    if (amount < 0) {
      bank_errno = NEGATIVE_AMOUNT;
      return (-1);
    }
    if (amount > bal[account_number]) {
      bank_errno = INSUFFICIENT_FUNDS;
      return (-2);
    }
    if (amount > MAX) {
      bank_errno = AMOUNT_TOO_LARGE;
      return(-3);
    }

    bal[account_number] -= amount;
    return(bal[account_number]);
}

int create(int account_number, int initial_balance)
{
    if ((account_number < 1)
	   ||
       (account_number > MAX_ACCOUNT_NUM)
           ||
       (initial_balance < 0))
    {
      return (-1);
    }

    bal[account_number] = initial_balance;
    return(account_number);
}

int get_balance(int account_number) {
    if ((account_number < 1)
	   ||
       (account_number > MAX_ACCOUNT_NUM))
    {
      return (-1);
    }

    return bal[account_number];
}
