/*
 Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
 Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
 Copyright (c) 1996-1998 The Open Group
 Copyright (c) 1994-1997 Sun Microsystems Inc.
 
 All rights reserved.
 This technology is a result of the Advanced Software  Enrichment 
 Project of Information-technology Promotion Agency, Japan (IPA).
 
 Permissions  to  use,  copy, modify and distribute this software
 are governed by the terms and conditions set forth in  the  file 
 COPYRIGHT, located in the top directory of this software.
 */

/************************************************************************

SCCS:           @(#)bank.h	1.1 11/19/96
PRODUCT:	Assertion Definition Language Translator (ADLT)
COMPONENT:	ADL 1 bank example rewritten for ADL version 2
NAME:		bank.h

HISTORY:
	Rob Duncan, Sun Microsystems Inc. - Jan 27, 1994: Created
		
************************************************************************/

#ifndef BANK_H
#define BANK_H 1

/*
 * bank.h
 * User implementation header for bank.c
 */

#define INSUFFICIENT_FUNDS 1
#define NEGATIVE_AMOUNT    2
#define INVALID_ACCOUNT    3
#define AMOUNT_TOO_LARGE   4

#define MAX_ACCOUNT_NUM    100

/* Maximum withdrawl per day */
#define MAX                200

typedef int account;

extern int bank_errno;

extern int get_balance(account account_number);

extern int deposit(account account_number, int amount);

extern int withdraw(account account_number,int amount);

extern account create (account account_number,
		       int initial_balance);

#endif /* BANK_H */
