// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// SCCS:        @(#)bankAux.hh	1.1 11/19/96
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bankAux.hh
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
#ifndef BANKAUX_HH
#define BANKAUX_HH

#include "bank.hh"

#define boolean int
#define true  1
#define false 0


// the functions below are aids for bank and bankAccount interface
// assertion evaluation.

extern const int maxAccountsDefault;

boolean bank_is_full      (bank &b);
boolean is_account_active (bank &b, long acctNumber);
boolean is_account_zero   (bank &b, long acctNumber);
#ifdef __ADL__
nld {
  bank_is_full()      = "the bank is full";
  is_account_active() = "the account is active";
  is_account_zero()   = "the account balance is zero";

}
#endif
#endif
