//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//  
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//  
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/examples/idl/bank_example/bankClient.java,v $
// $Revision: 1.3 $
// $Date: 1998/02/27 15:46:31 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example
// NAME:	bankClient.java
// 	
// HISTORY:
// 	Cyril Inard d'Argence, The Open Group - Jan 13, 1998: Created
// 		
// ************************************************************************

package bank_example;

import bank_example.bank_app.*;
import java.io.*;
import org.omg.CORBA.*;


/**	
 *  class bankClient
 */

public class bankClient {

  public static void main(String args[])
  {
     
     try{
        // create and initialize the ORB
        ORB orb = ORB.init(args, null);
        
        BufferedReader br = new BufferedReader(new FileReader("BankIOR"));
        String ior = br.readLine();
        br.close();

        org.omg.CORBA.Object obj = orb.string_to_object(ior);
        bankFactory bankFactoryRef = bankFactoryHelper.narrow(obj);

        // create one bank
        bank bankRef = bankFactoryRef.create_bank();

        // open one account
        IntHolder accountNumberHolder = new IntHolder();
        bankAccount accountRef = bankRef.open_account(50,accountNumberHolder);

        System.out.println
        ("Account number " +accountNumberHolder.value + " opened.");

        // get balance
        System.out.println("Account balance is " + accountRef.balance());

        // deposit money
        accountRef.deposit(50);
        System.out.println("Made deposit of 50.");

        // get balance
        System.out.println("Account balance is " + accountRef.balance());

     } catch (Exception e) {
        System.out.println("ERROR : " + e) ;
        e.printStackTrace(System.out);
     }
  }
}

// ***********************************************************************
// History Log:
// $Log: bankClient.java,v $
// Revision 1.3  1998/02/27 15:46:31  cinard
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:04:15  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/02/02 13:30:04  cinard
// Example of CORBA testing using ADL for Java.
//
// ***********************************************************************

