//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//  
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//  
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/examples/idl/stock_example/StockServer.java,v $
// $Revision: 1.4 $
// $Date: 1998/02/27 15:46:36 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	stock example
// NAME:	StockServer.java
// 	
// HISTORY:
// 	Cyril Inard d'Argence, The Open Group - Feb 5, 1998: Created
// 		
// ************************************************************************

package stock_example;

import stock_example.stock_app.*;
import ORG.opengroup.adl.runtime.ORBWrapper;

import java.io.*;


/**	
 *  class StockServer using the ADL ORB Wrapper
 */

public class StockServer {

  public static ORBWrapper _orbWrapper;

  /** Main
  **/
  public static void main(String[] args)
  {
    try
    {
      // create and initialize ORB
      _orbWrapper = ORBWrapper.init(args, null);

      // create Servant and register it with ORB
      StockBrokerFactoryImpl servant = new StockBrokerFactoryImpl();
      _orbWrapper.connect(servant);

      // put a stringified  reference to the servant in a file for further
      // retrieving by a client
      String fileName = System.getProperty
                        ("adl.initialreferencefile",
                         "StockIOR");
      PrintWriter pw = new PrintWriter(new FileWriter(fileName));
      pw.print(_orbWrapper.object_to_string(servant));
      pw.close();

      // wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized (sync) {
         sync.wait();
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
      System.err.println("Bank Server: Exception-> " + ex);
    }
  }

}

// ***********************************************************************
// History Log:
// $Log: StockServer.java,v $
// Revision 1.4  1998/02/27 15:46:36  cinard
// Updated copyright notice.
//
// Revision 1.3  1998/02/17 10:57:29  mallet
// Merged v1.0 with development trunk
//
// Revision 1.2.2.1  1998/02/16 20:28:19  cinard
// New location of ORBWrapper taken into account.
//
// Revision 1.2  1998/02/12 16:04:23  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/02/10 17:36:10  cinard
// Implementations for IDL interfaces and other useful classes.
//
// ***********************************************************************

