//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/c/ADLFactorySet.h,v $
// $Revision: 1.2 $
// $Date: 1998/04/30 17:01:31 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C Runtime Environment - Factory set class
// NAME:	ADLFactorySet.h
// 	
// HISTORY:
//      Shane McCarron, The Open Group - 11 April 1998: Converted
//      Lionel Mallet, The Open Group RI  - Nov  2, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#ifndef ADLFactorySet_h
#define ADLFactorySet_h

#include "ADLParameterSet.h"
#include "ADLDataSet.h"
#include "ADLRuntimeException.h"

ADLDataSet *ADL_FactorySetInit(char *fname);
void ADL_FactoryAddParameter(ADLDataSet *f, ADLDataSet *e);
int ADL_FactoryGetNumElements(ADLDataSet *f);

#endif // ADLFactorySet_h

// ***********************************************************************
// History Log:
// $Log: ADLFactorySet.h,v $
// Revision 1.2  1998/04/30 17:01:31  shane
// Fixed a few inconsistencies.
//
// Revision 1.1  1998/04/16 12:09:10  shane
// First checkin of complete set.
//
//
// ***********************************************************************
