//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/c/ADLMemory.h,v $
// $Revision: 1.4 $
// $Date: 1998/08/06 13:27:35 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   C Runtime Environment - Memory allocation routines
// NAME:        ADLMemory.h
//
// HISTORY:
//      Shane McCarron, The Open Group - 10 April 1998
//      See Log at end of file
//
// ***********************************************************************

#ifndef ADLMemory_h
#define ADLMemory_h

#include <sys/types.h>
#ifdef WIN32
#include <stddef.h>
#endif

void *ADL__malloc(size_t);

void *ADL__calloc(size_t, size_t);

void *ADL__realloc(void *, size_t);

void ADL__free(void *);

char *ADL__new_string(char *);

#endif  // ADLMemory_h

// ***********************************************************************
// History Log:
// $Log: ADLMemory.h,v $
// Revision 1.4  1998/08/06 13:27:35  mallet
// Merged Shane's last change on branch v1_2-patches onto the trunk.
//
// Revision 1.3  1998/07/21 13:35:42  mallet
// Added new function ADL__new_string().
//
// Revision 1.2.2.1  1998/07/22 15:20:53  shane
// Changed to include stddef.h on WIN32 platforms.
//
// Revision 1.2  1998/05/11 12:54:09  shane
// Changed _ADL_* symbols to ADL__* since our naming convention says that all ADL
// symbols should start with ADL or tdd.
//
// Revision 1.1  1998/04/16 12:09:11  shane
// First checkin of complete set.
//
//
// ***********************************************************************
