//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/c/ADLParameterSet.h,v $
// $Revision: 1.2 $
// $Date: 1998/05/11 12:54:10 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C Runtime Environment - Test directive and factory 
//                                      parameter set class
// NAME:	ADLParameterSet.h
// 	
// HISTORY:
//      Shane McCarron, The Open Group - 10 April 1998: Converted to C
//      Lionel Mallet, The Open Group RI  - Oct  26, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#ifndef ADLParameterSet_h
#define ADLParameterSet_h

#include "ADLDataSet.h"

/*
 *  struct ADLParameterSet
 *
 *  The ADLParameterSet implements a list of dataset parameters for
 *  test directive and factory parameters.
 *
 *  @see ADLDataSet
 *
 */
struct ADLParameterSet {
    struct ADLDataSet *elementSet;
    int numElements;
    int numValues;
    int *elementIndexes;
};

typedef struct ADLParameterSet ADLParameterSet;

ADLParameterSet *ADL_ParameterSetInit();

int ADL__getNumValues(ADLParameterSet *p);

int ADL__getNumElements(ADLParameterSet *p);

void ADL__addElement(ADLParameterSet *p, ADLDataSet *e);

void **ADL__provide(ADLParameterSet *p, int index);

int ADL__relinquish(ADLParameterSet *p, int index);

#endif // ADLParameterSet_h

// ***********************************************************************
// History Log:
// $Log: ADLParameterSet.h,v $
// Revision 1.2  1998/05/11 12:54:10  shane
// Changed _ADL_* symbols to ADL__* since our naming convention says that all ADL
// symbols should start with ADL or tdd.
//
// Revision 1.1  1998/04/16 12:09:12  shane
// First checkin of complete set.
//
//
// ***********************************************************************
