//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/c/ADLRuntimeException.h,v $
// $Revision: 1.1 $
// $Date: 1998/04/16 12:09:13 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   C Runtime Environment - Runtime exception routines
// NAME:        ADLRuntimeException.h
//
// HISTORY:
//      Shane McCarron, The Open Group - Apr 10 1998: Converted
//      Lionel Mallet, The Open Group RI - Jan 22, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

#ifndef ADLRuntimeException_h
#define ADLRuntimeException_h

#define ADL_ExceptionLen 1024

typedef enum {None, ADLOutOfMemory, ADLRuntime, ADLEndCase, ADLEndTest} ADLRuntimeExceptionType;

void ADL_ClearException();

void ADL_RaiseExceptionType(ADLRuntimeExceptionType);

void ADL_RaiseException(ADLRuntimeExceptionType, char *message, ...);

ADLRuntimeExceptionType ADL_GetExceptionType();

int ADL_GetException();

char *ADL_GetExceptionMessage();

#endif // ADLRuntimeException_h

// ***********************************************************************
// History Log:
// $Log: ADLRuntimeException.h,v $
// Revision 1.1  1998/04/16 12:09:13  shane
// First checkin of complete set.
//
//
// ***********************************************************************
