//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/cpp/ADLLiteralSet.cpp,v $
// $Revision: 1.12 $
// $Date: 1998/03/03 10:46:26 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C++ Runtime Environment - Test directive and factory 
//                                        parameter set class
// NAME:	ADLLiteralSet.cpp
// 	
// HISTORY:
//      Lionel Mallet, The Open Group RI  - Oct  28, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#include "ADLLiteralSet.hh"

short ADLLiteralSet::chunkNumberOfValues = 5;

#ifdef __GNUG__
ADLLiteralSet::ADLLiteralSet(ADLTest *tc, bool vals[], int size) : 
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  bool *theValues = new bool[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}
#endif

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, char vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  char *theValues = new char[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, unsigned char vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  unsigned char *theValues = new unsigned char [numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, short vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  short *theValues = new short[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, unsigned short vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  unsigned short *theValues = new unsigned short [numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, int vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  int *theValues = new int[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, unsigned int vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  unsigned int *theValues = new unsigned int [numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, long vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  long *theValues = new long[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, unsigned long vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  unsigned long *theValues = new unsigned long [numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, float vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  float *theValues = new float[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, double vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  double *theValues = new double[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, long double vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  long double *theValues = new long double [numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

ADLLiteralSet::ADLLiteralSet(ADLTest *tc, void *vals[], int size) :
  ADLDataSet(tc), typeSize(sizeof *vals){

  numValues = size;
  void **theValues = new void *[numValues];
  for (int i = 0; i < numValues; i++) {
    theValues[i] = vals[i];
  }
  values = (void *)theValues;
}

// Note that it returns the address of the value and not the value itself
// User must dereference even in case of void * or char *.
void *ADLLiteralSet::provide(int index) throw (ADLRuntimeException) {
  checkBounds(index);

  void *eltAdr = (void *)((char *)values + (index * typeSize));
  return eltAdr;
}

bool ADLLiteralSet::relinquish(int index) throw (ADLRuntimeException) {
  checkBounds(index);

  return true;
}

void ADLLiteralSet::setValues(ADLLiteralSet* copySet) {
  values = copySet->values;
  numValues = copySet->numValues;
  typeSize = copySet->typeSize;
}

#ifdef __GNUG__
void ADLLiteralSet::addValue(bool value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}
#endif

void ADLLiteralSet::addValue(char value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(unsigned char value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(short value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(unsigned short value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(int value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(unsigned int value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(long value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(unsigned long value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(float value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(double value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(long double value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::addValue(void *value) throw (ADLRuntimeException) {
  if ((sizeof value) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add value with different type size!");
  }
  doAddValue(&value);
}

void ADLLiteralSet::doAddValue(void *value) {
  if (numValues == 0) {
    // needs malloc
    maxNumberOfValues = chunkNumberOfValues;
    values = malloc(maxNumberOfValues * typeSize);
  } else if (numValues == maxNumberOfValues) {
    // needs realloc
    maxNumberOfValues += chunkNumberOfValues;
    values = realloc(values, maxNumberOfValues * typeSize);
  }

  if (values == NULL) {
    // malloc/realloc failed
    throw ADLRuntimeException(ADLRuntime, 
			      "ADLLiteralSet: can't malloc/realloc to add new value!");
  } else {
    memcpy(((char *)values + (numValues * typeSize)), value, typeSize);
    numValues++;
  }
}

void ADLLiteralSet::addRangeValues(char minValue, char maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (char i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (char i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    }
  }
}

void ADLLiteralSet::addRangeValues(unsigned char minValue,
				   unsigned char maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (unsigned char i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (unsigned char i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    } 
  }
}

void ADLLiteralSet::addRangeValues(short minValue, short maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (short i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (short i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    }
  }
}

void ADLLiteralSet::addRangeValues(unsigned short minValue,
				   unsigned short maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (unsigned short i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (unsigned short i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    } 
  }
}

void ADLLiteralSet::addRangeValues(int minValue, int maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (int i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (int i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    }
  }
}

void ADLLiteralSet::addRangeValues(unsigned int minValue,
				   unsigned int maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (unsigned int i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (unsigned int i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    }
  }
}

void ADLLiteralSet::addRangeValues(long minValue, long maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (long i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (long i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    }
  }
}

void ADLLiteralSet::addRangeValues(unsigned long minValue,
				   unsigned long maxValue)
  throw (ADLRuntimeException) {

  if ((sizeof minValue) != typeSize) {
    throw ADLRuntimeException(ADLRuntime,
			      "ADLLiteralSet: can't add range values with different type size!");
  } else {
    if (minValue < maxValue) {
      for (unsigned long i = minValue; i <= maxValue; i++) {
	doAddValue(&i);
      }
    } else {
      for (unsigned long i = minValue; i >= maxValue; i--) {
	doAddValue(&i);
      }
    }
  }
}

// ***********************************************************************
// History Log:
// $Log: ADLLiteralSet.cpp,v $
// Revision 1.12  1998/03/03 10:46:26  mallet
// Optimized doAddValue by allocating chunks of chunkNumberOfValues
// instead of just one value. This reduces the number of
// malloc/realloc. chunkNumberOfValues is initially set to 5. This value
// would have to be refined according to some measurements of the mean
// number of values in a literal dataset in ADL test suites.
//
// Revision 1.11  1998/03/02 17:41:59  mallet
// Fixed bug in doAddValue that was causing the SEGV in free and
// previously in realloc: was offsetting the values pointer by setting it
// to the memcpy result while adding the element.
// Reverted to the realloc version of the code for doAddValue.
//
// Revision 1.10  1998/02/27 09:53:59  mallet
// Fixed a memory leak in doAddValue introduced while replacing realloc
// by malloc+memcpy.
// Updated copyright notice.
//
// Revision 1.10  1998/02/27 09:49:40  mallet
// Fixed a memory leak in doAddValue introduced while replacing realloc
// by malloc+memcpy.
// Updated copyright notice.
//
// Revision 1.9  1998/02/26 16:51:56  mallet
// Fixed bug in doAddValue: realloc was causing a SEGV for unknown
// reasons, replacing it with a new malloc and memcpy fixes that bug.
//
// Revision 1.8  1998/02/26 12:38:41  mallet
// Added the addValue methods for all builtin types to allow to add a
// value without passing its address: this is more robust since it is
// possible to check that the size of the type of the added value is
// compatible with the size of the other values in the dataset.
// Renamed previous addValue(void *) as doAddValue(void *): use this to
// finally add a value in addValue and addRangeValues methods.
//
// Revision 1.8  1998/02/26 10:22:35  mallet
// Added the addValue methods for all builtin types to allow to add a
// value without passing its address: this is more robust since it is
// possible to check that the size of the type of the added value is
// compatible with the size of the other values in the dataset.
// Renamed previous addValue(void *) as doAddValue(void *): use this to
// finally add a value in addValue and addRangeValues methods.
//
// Revision 1.7  1998/02/26 09:22:13  mallet
// Made addValue method public.
// Added missing contructors for some builtin types (unsigned ..., long
// double).
// Added addRangeValues methods for integral types (unsigned char -> long).
//
// Revision 1.6  1998/02/19 09:59:06  mallet
// Added missing initializations in ADLLiteralSet(ADLTest) constructor:
// values and typeSize.
// Added new constructor ADLLiteralSet(ADLTest, short) to create a
// literal set with no initial value (see addValue).
// Added a new method addValue to add a new value to an ADLLiteralSet:
// note that no check is done on the size of the passed value w.r.t. the
// size of the expected value for the literal set.
// Changed signature of provide and relinquish to throw an
// ADLRuntimeException when checkBounds fails.
// Changed use of checkBounds in provide and relinquish according to its
// new signature.
//
// Revision 1.5  1998/02/12 16:04:27  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.4  1998/02/11 18:10:23  mallet
// Fixed a bug in setValues: forgot to copy typeSize field.
//
// Revision 1.3  1998/01/29 12:53:46  bareau
// Update of the C++ runtime.
// In ADLFactorySet, factory_relinquish is no more virtual
// but has a default behavior "return true".
// In ADLLiteralSet, added a default constructor with one parameter
// ADLTest *, and a method "void setValues(ADLLiteralSet* copySet)"
// to create an ADLLiteralSet from an other one.
//
// Revision 1.2  1997/11/21 16:54:26  mallet
// Added an ifdef __GNUG__ around bool constructor for compilers in which
// bool is defined as int.
// Added a size argument to all constructors since the size of the array
// cannot be computed.
// Added a cast for void* pointer for compilers which refuses to add an
// offset to a void* pointer.
//
// Revision 1.1  1997/11/14 10:13:30  mallet
// Initial version of runtime classes for TDD datasets and ACOs.
//
//
// ***********************************************************************
