//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/cpp/ADLObjectACO.hh,v $
// $Revision: 1.1 $
// $Date: 1998/06/17 10:13:14 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C++ Runtime Environment - ACO root class
// NAME:	ADLObjectACO.hh
// 	
// HISTORY:
//      Lionel Mallet, The Open Group RI  - Oct  26, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#ifndef ADLObjectACO_hh
#define ADLObjectACO_hh

#include "ADLTest.hh"
#include <stdlib.h>
#include <string.h>

class ADLObjectACO {
protected:
  ADLTest *testContext; // the current test context, providing
  // access to TET reporting methods

  void *realObject; // the actually tested object

  bool debugMode; // debug mode indicator

  bool finalJournalReporting; // top level journal reporting
  // indicator. Each ACO method which will delegate part of its assertion
  // checking to one of its super class will set this to false before.

  bool skipAssertions; // local skip assertions indicator,
  // used to propagate this information between super/sub classes.

  ADLObjectACO(void *object, ADLTest *tc);
};

#endif // ADLObjectACO_hh

// ***********************************************************************
// History Log:
// $Log: ADLObjectACO.hh,v $
// Revision 1.1  1998/06/17 10:13:14  mallet
// Renamed ObjectACO to ADLObjectACO.
//
// Revision 1.3  1998/02/27 10:01:09  mallet
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:04:32  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1997/11/14 10:13:32  mallet
// Initial version of runtime classes for TDD datasets and ACOs.
//
//
// ***********************************************************************
