//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togdev/cvsroot/adl2/src/runtime/cpp/ADLResultCodes.h,v $
// $Revision: 1.6 $
// $Date: 1998/02/27 10:01:05 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	Standard ADL result codes.
// NAME:	ADLResultCodes.h
// 	
// HISTORY:
// 	Lionel Mallet, The Open Group RI - Oct 29, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#ifndef ADLResultCodes_h
#define ADLResultCodes_h

#ifndef TET_PASS
#include "tet_api.h"
#endif

#define ADL_PASS TET_PASS
#define ADL_FAIL TET_FAIL
#define ADL_UNRESOLVED TET_UNRESOLVED
#define ADL_NOTINUSE TET_NOTINUSE
#define ADL_UNSUPPORTED TET_UNSUPPORTED
#define ADL_UNTESTED TET_UNTESTED
#define ADL_UNINITIATED TET_UNINITIATED
#define ADL_NORESULT TET_NORESULT

#define ADL_UNEVALUATED 	1003
#define ADL_ERROR 		1004
#define ADL_SKIPPED 		1005
#define ADL_AMBIGUOUS 		1006
#define	ADL_UNDEFINED		1007

#endif // ADLResultCodes_h

// ***********************************************************************
// History Log:
// $Log: ADLResultCodes.h,v $
// Revision 1.6  1998/02/27 10:01:05  mallet
// Updated copyright notice.
//
// Revision 1.5  1998/02/12 16:04:29  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.4  1998/02/11 18:43:25  shane
// Changed codes to match those of ADL1 (including precedence).
// Added ADL_ERROR code.  Should never happen, but is supposed to represent an
// execution error.
//
// Revision 1.3  1998/02/11 18:05:23  mallet
// Added new code ADL_SKIPPED which is raised when tdd_skip is called.
//
// Revision 1.2  1998/01/19 14:37:40  mallet
// Added #ifndef TET_PASS around tet_api.h include to avoid duplicate
// definition of tet types.
// Fixed initialization of tet_testlist in ADLTestCase.cpp for GCC.
//
// Revision 1.1  1997/11/14 10:13:31  mallet
// Initial version of runtime classes for TDD datasets and ACOs.
//
// Revision 1.1  1997/10/22 11:27:59  shane
// Initial version.
//
//
// ***********************************************************************
